package InstantSocial;

import org.istmusic.mw.adaptation.configuration.ConfigurableImpl;
import org.istmusic.mw.model.connectable.IConnectable;

import shared.IPresentationServiceProvider;

import InstantSocial.simpleBrowserProxy.BPFrame;

public class SimpleBrowserProxy extends ConfigurableImpl implements IBrowserProxy, IConnectable{

	private IPresentationServiceProvider presentation;
	private BPFrame browserFrame;
	
	public SimpleBrowserProxy(){
		super();
		System.out.println("SimpleBrowserProxy created");
		startBrowser();
	}
	
	@Override
	public void startBrowser() {
		if(browserFrame == null){
			browserFrame = new BPFrame();
		}
		if(presentation != null){
			browserFrame.setPresentationProvider(presentation);
		}
	}

	@Override
	public void addConnection(String arg0, Object arg1) {
		if(arg0.equals("<pn")){
			presentation = (IPresentationServiceProvider) arg1;
		}
		if(browserFrame != null){
			browserFrame.setPresentationProvider(presentation);
		}
		else{
			startBrowser();
		}
		
	}

	@Override
	public void removeConnection(String arg0, Object arg1) {
		presentation = null;
		
	}
	
	

}
