package InstantSocial.simpleBrowserProxy;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import shared.IPresentationServiceProvider;

import javax.swing.*;


public class BPPane extends JPanel implements ActionListener{

	
	private enum mode{
		THUMBNAILS,
		SINGLEIMAGE
	}


	private static final long serialVersionUID = 1L;
	private JPanel thumbPanel;
	private JLabel header;
	private JButton viewAllButton;
	private IPresentationServiceProvider presentation;
	
	private ArrayList<JButton> thumbnails;
	private JButton selectedImage;
	
	public BPPane() {
		
		this.setBackground(Color.WHITE);
		//BoxLayout box = new BoxLayout(this, BoxLayout.PAGE_AXIS);
		//this.setLayout(box);
		
		this.setAlignmentX(LEFT_ALIGNMENT);
		//this.setAlignmentX(Component.LEFT_ALIGNMENT);
		//this.setSize(200, 300);
		this.setPreferredSize(new Dimension(250,300));
		this.setMaximumSize(new Dimension(250,300));
		
		header = new JLabel("BROWSER PROXY TEST");
		header.setAlignmentX(Component.LEFT_ALIGNMENT);
		
		
		thumbPanel = new JPanel();
		thumbPanel.setSize(250,250);
		thumbPanel.setMaximumSize(new Dimension(250,250));
		thumbPanel.setPreferredSize(new Dimension(250,250));
		thumbPanel.setMinimumSize(new Dimension(250,250));
		thumbPanel.setBackground(Color.LIGHT_GRAY);
		
		//SpringLayout g = new SpringLayout();
		//GridLayout g = new GridLayout(0,2);
		//g.setHgap(20);
		//g.setVgap(20);
		//thumbPanel = new JPanel(new BoxLayout(thumbPanel, BoxLayout.Y_AXIS));
		//thumbPanel = new JPanel(g);
		
		//
		
		viewAllButton = new JButton("View All");
		viewAllButton.setAlignmentX(LEFT_ALIGNMENT);
		
		viewAllButton.addActionListener(this);
		
		
		addHeader();
		
		this.add(thumbPanel);
	}
	
	public void addHeader(){
		this.add(header, LEFT_ALIGNMENT);
		this.add(viewAllButton, Box.LEFT_ALIGNMENT);
	}

	@Override
	public void actionPerformed(ActionEvent arg0) {

		if(arg0.getSource() == viewAllButton){
			//System.out.println("viewallbutton pressed");
			getAndLoadThumbnailPictures();
		}
		else if(arg0.getSource() instanceof JButton){
			JButton source = (JButton) arg0.getSource();
			String filename = ((ImageIcon)source.getIcon()).getDescription();
			//System.out.println(filename);
			changeToSingleImage(filename);
		}
		
	}
	
	private void getAndLoadThumbnailPictures(){
		
		//get imageicon list
		ArrayList<ImageIcon> thumblist = presentation.getAllThumbnails();
		thumbnails = new ArrayList<JButton>();
		
		for (ImageIcon icon : thumblist) {
			JButton button = new JButton(icon);
			button.setSize(60, 60);
			button.setPreferredSize(new Dimension(60,60));
			button.setMaximumSize(new Dimension(60,60));
			//button.setAlignmentX(Component.LEFT_ALIGNMENT);
			button.addActionListener(this);
			thumbnails.add(button);
		}
		

	
	//place the buttons!
	distributeThumbnails();
		
	}
	
	
	/*
	private void getAndLoadPictures(){
		if(presentation != null){
			String thumblist = presentation.getAllThumbnails();
			
			//System.out.println("GOT LIST: " + thumblist);
			thumbnails = new ArrayList<JButton>();
			
			
			//Removing <xml> tags
			thumblist = thumblist.substring(thumblist.indexOf('>') + 1);
			
			String nexttag = thumblist.substring(0, thumblist.indexOf('>') + 1);
			//System.out.println("nexttag = " + nexttag);
			boolean hasMoreElements = false;
			if (nexttag.equals("<picture>")){
				hasMoreElements = true;
			}
			
			thumblist = thumblist.substring(0, thumblist.lastIndexOf('<'));
			
			//System.out.println("fixed list : " + thumblist);
			
			//parse xml list to get all filenames
			ArrayList<String> filenames = new ArrayList<String>();
			
			while(hasMoreElements){
				nexttag = thumblist.substring(0, thumblist.indexOf('>') + 1);
				if (nexttag.equals("<picture>")){
					
					String filename = thumblist.substring(thumblist.indexOf("<picture>") + 9, thumblist.indexOf("</picture>"));
					//System.out.println("filename = " + filename);
					filenames.add(filename);
					thumblist = thumblist.substring(thumblist.indexOf("</picture>") + 10);
				}
				else{
					hasMoreElements = false;
				}
				
			}
			
			//create the buttons:
			
			
			for (String filename : filenames) {
				String thumbname = filename.substring(0, filename.indexOf('.')) + "_THUMB" + filename.substring(filename.indexOf('.'));
				//System.out.println(thumbname);
				ImageIcon icon = new ImageIcon(testFileLocation + thumbname);
				JButton button = new JButton(icon);
				button.setSize(60, 60);
				button.setPreferredSize(new Dimension(60,60));
				button.setMaximumSize(new Dimension(60,60));
				button.setAlignmentX(Component.CENTER_ALIGNMENT);
				thumbnails.add(button);
			}
			
			
			//place the buttons!
			distributeThumbnails();
			
			
			
		}
		else{
			System.err.println("No Presentation Provider Added!");
		}
	}
	*/
	
	private void distributeThumbnails(){
		//thumbPanel.removeAll();
		this.removeAll();
		thumbPanel.removeAll();
		
		this.addHeader();
		this.add(thumbPanel, LEFT_ALIGNMENT);
		
		for (JButton button : thumbnails) {
			
			thumbPanel.add(button);
		}
		
		this.getParent().paintAll(getGraphics());
	}
	
	private void changeToSingleImage(String filename){
		ImageIcon icon = presentation.getSingleFullImage(filename);
		
		selectedImage = new JButton(icon);
		selectedImage.setSize(200, 300);
		selectedImage.setPreferredSize(new Dimension(200, 300));
		selectedImage.setMaximumSize(new Dimension(200, 300));
		selectedImage.setAlignmentX(Component.CENTER_ALIGNMENT);
		//selectedImage.addActionListener(this);
		
		
		this.removeAll();
		this.addHeader();
		this.add(selectedImage);
		
		this.getParent().paintAll(getGraphics());
	}
	
	public IPresentationServiceProvider getPresentation() {
		return presentation;
	}

	public void setPresentation(IPresentationServiceProvider presentation) {
		this.presentation = presentation;
	}
	

}