package roisensor;


import org.istmusic.mw.context.plugins.*;
import org.istmusic.mw.context.events.ContextChangedEvent;
import org.istmusic.mw.context.model.api.IContextElement;
import org.istmusic.mw.context.model.impl.ContextElement;

import shared.roiContext.model.RoiContextElement;

public class RoiSensor extends AbstractContextPlugin
{
    public static final String PLUGIN_ID = "Roi Sensor";

    private final VisualRoiChanger visualRoiChanger;

    public RoiSensor()
    {
        super(PLUGIN_ID);

        visualRoiChanger = new VisualRoiChanger(this);
        //visualRoiChanger.setVisible(true);
    }

    public void activate()
    {
        System.out.println("ACTIVATING ROI SENSOR!");
        //new RoiCommandChanger(this);
        //roiChange(75);

        visualRoiChanger.setVisible(true);
    }

    public void deactivate()
    {
        System.out.println("DEACTIVATING ROI SENSOR!");
        super.deactivate();

        visualRoiChanger.setVisible(false);
    }


    public void roiChange(int newValue)
    {
        System.out.println("FIRING CONTEXTCHANGED EVENT !");
        RoiContextElement contextElement = new RoiContextElement(PLUGIN_ID, newValue);
        fireContextChangedEvent(this, contextElement);
    }

}
