package shared.roiContext.model;

import org.istmusic.mw.context.model.api.*;
import org.istmusic.mw.context.model.impl.values.DoubleValue;
import org.istmusic.mw.context.model.impl.values.IntegerValue;
import org.istmusic.mw.context.model.impl.Factory;
import org.istmusic.mw.context.ontologies.DefaultMusicOntologyV0_1;

public class RoiContextValue implements IContextValue
{
    public static final IScope ROI_CONTEXT_VALUE_SCOPE = Factory.createScope("#Thing.Concept.Scope.RoiValue");

    //WHAT THE ?
    //public static final IScope SCOPE = DefaultMusicOntologyV0_1.s;
    public static final IRepresentation REPRESENTATION = DefaultMusicOntologyV0_1.REPRESENTATION_BASIC_INTEGER;

    private final IntegerValue roi;

    public RoiContextValue(int roi)
    {
        this.roi = new IntegerValue(roi);
    }

    public int getRoi()
    {
        return roi.getIntegerValue();
    }

    public IMetadata getMetadata()
    {
        return IMetadata.EMPTY_METADATA;
    }

    public IRepresentation getRepresentation()
    {
        return REPRESENTATION;
    }

    public IScope getScope()
    {
        return ROI_CONTEXT_VALUE_SCOPE;
    }

    public IValue getValue()
    {
        return roi;
    }
}