/**
 * The MUSIC project (Contract No. IST-035166) is an Integrated Project (IP) 
 * within the 6th Framework Programme, Priority 2.5.5 (Software and Services).
 *
 * More information about the project is available at: http://www.ist-music.eu
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307 USA
 */

// TODO: package name generation/checking
package InstantSocial;

import org.istmusic.mw.model.*;
import org.istmusic.mw.model.property.*;
import org.istmusic.mw.resources.impl.descriptors.ResourceVocabulary;
import java.util.HashMap;
import java.util.Map;
import java.util.Vector;


/**
 * This class implements the InstantSocial bundle
 * <p/>
 * Date: 2/7/2009
 * Time: 18:35:15   
 * 
 * @author Transformation Tool   
 */

public class InstantSocial implements IBundle {
    // Type Names
	private static MusicName InstantSocial = MusicName.nameFromString("/type/InstantSocial/InstantSocial");
	private static MusicName BrowserProxy_Type = MusicName.nameFromString("/type/InstantSocial/BrowserProxy_Type");
	private static MusicName Presentation_Type = MusicName.nameFromString("/type/InstantSocial/Presentation_Type");
	private static MusicName ContentRepository_Type = MusicName.nameFromString("/type/InstantSocial/ContentRepository_Type");
	private static MusicName ContentRepositoryProxy_Type = MusicName.nameFromString("/type/InstantSocial/ContentRepositoryProxy_Type");
	private static MusicName MembershipProxy_Type = MusicName.nameFromString("/type/InstantSocial/MembershipProxy_Type");
	private static MusicName PresentationProxy_Type = MusicName.nameFromString("/type/InstantSocial/PresentationProxy_Type");
	// Names
	private static String isNotAvailable_Name = "isNotAvailable";
	private static String isFull_Name = "isFull";
	private static String isMini_Name = "isMini";
	private static String isLeech_Name = "isLeech";
	private static String SimpleBrowserProxy_Name = "SimpleBrowserProxy";
	private static String LocalPresentation_Name = "LocalPresentation";
	private static String ContentRepository_Name = "ContentRepository";

	public static final int defaultCrut = 50;
	
	//Create and install plans
    private AtomicPlan[] getAtomicPlans(){
        AtomicPlan[] ATOMIC_PLANS = new AtomicPlan[4];
		String[] contextDep_0 = {
		};
		//ATOMIC_PLANS[0] = new AtomicPlan(isNotAvailable_Name, InstantSocial, "isNotAvailable", contextDep_0);
		ATOMIC_PLANS[0] = new AtomicPlan(isNotAvailable_Name, InstantSocial, isNotAvailable.class.getName(), contextDep_0);

		{

			Map propertyMap = myCreateMap(
				new String[]{"rut", "avy", IPropertyEvaluator.UTILITY_PROPERTY },
					new Object[]{
						new ConstProperty(new Integer(99)), 
						new ConstProperty(new Integer(1)), 
						new Utility()});

			Map resourceMap = myCreateMap(
				new String[]{},
					new Object[]{});

			Feature[] features = {
			};

			ATOMIC_PLANS[0].addPlanVariant(propertyMap, null, resourceMap, features);

		}
		String[] contextDep_1 = {
			//new String("#Thing.Concept.EntityType.Device;#Thing.Concept.Scope.Roi")
		};
		//ATOMIC_PLANS[1] = new AtomicPlan(ContentRepository_Name, ContentRepository_Type, "InstantSocial.LocalContentRepository", contextDep_1);
		ATOMIC_PLANS[1] = new AtomicPlan(ContentRepository_Name, ContentRepository_Type, LocalContentRepository.class.getName(), contextDep_1);

		{

			Map propertyMap = myCreateMap(
				new String[]{},
					new Object[]{});

			Map resourceMap = myCreateMap(
				new String[]{"JVMMemoryResourceService"},
					new Object[]{
						new Integer(10000)});

			Feature[] features = {
			};

			ATOMIC_PLANS[1].addPlanVariant(propertyMap, null, resourceMap, features);

		}
		String[] contextDep_2 = {
		};
		//ATOMIC_PLANS[2] = new AtomicPlan(SimpleBrowserProxy_Name, BrowserProxy_Type, "InstantSocial.SimpleBrowserProxy", contextDep_2);
		ATOMIC_PLANS[2] = new AtomicPlan(SimpleBrowserProxy_Name, BrowserProxy_Type, SimpleBrowserProxy.class.getName(), contextDep_2);

		{

			Map propertyMap = myCreateMap(
				new String[]{},
					new Object[]{});

			Map resourceMap = myCreateMap(
				new String[]{"JVMMemoryResourceService"},
					new Object[]{
						new Integer(7000)});

			Feature[] features = {
			};

			ATOMIC_PLANS[2].addPlanVariant(propertyMap, null, resourceMap, features);

		}
		String[] contextDep_3 = {
		};
		//ATOMIC_PLANS[3] = new AtomicPlan(LocalPresentation_Name, Presentation_Type, "InstantSocial.LocalPresentation", contextDep_3);
		ATOMIC_PLANS[3] = new AtomicPlan(LocalPresentation_Name, Presentation_Type, LocalPresentation.class.getName(), contextDep_3);

		{

			Map propertyMap = myCreateMap(
				new String[]{},
					new Object[]{});

			Map resourceMap = myCreateMap(
				new String[]{"JVMMemoryResourceService"},
					new Object[]{
						new Integer(7000)});

			Feature[] features = {
			};

			ATOMIC_PLANS[3].addPlanVariant(propertyMap, null, resourceMap, features);

		}
		return ATOMIC_PLANS;

	}//getAtomicPlans()

	private ServicePlan[] getServicePlans(){
        ServicePlan[] SERVICE_PLANS = new ServicePlan[3];

        //hand coded!
        //Map properties = ConstProperty.createMap(new String[]{"clockPrecision"}, new Object[]{new Integer(60)});
        //SERVICE_PLANS[0] = new ServicePlan(SimpleClock_Name, Clock_Type, "osgi", "urn:schemas-upnp-org:device:clock:1", properties );

        Map properties1 = ConstProperty.createMap(new String[]{"avy", "rut"}, new Object[]{new Integer(10), new Integer(80)});
        SERVICE_PLANS[0] = new ServicePlan("PresentationService", PresentationProxy_Type, "osgi", "service:music:PresentationService", properties1 );

        Map properties2 = ConstProperty.createMap(new String[]{"avy", "rut"}, new Object[]{new Integer(10), new Integer(80)});
        SERVICE_PLANS[1] = new ServicePlan("ContentRepositoryService", ContentRepositoryProxy_Type, "osgi", "service:music:ContentRepositoryService", properties2 );

        Map properties3 = ConstProperty.createMap(new String[]{"avy", "noi"}, new Object[]{new Integer(10), new Integer(1)});
        SERVICE_PLANS[2] = new ServicePlan("MembershipService", MembershipProxy_Type, "osgi", "service:music:MembershipService", properties3 );

        
		return SERVICE_PLANS;

	}//getServicePlans()

    private CompositionPlan[] getCompositionPlans()
    {
        HashMap roleMap = new HashMap();

		roleMap.put("BrowserProxy_Type_Role", new Role("BrowserProxy_Type_Role", BrowserProxy_Type));
		roleMap.put("ContentRepository_Type_Role", new Role("ContentRepository_Type_Role", ContentRepository_Type));
		roleMap.put("MembershipProxy_Type_Role", new Role("MembershipProxy_Type_Role", MembershipProxy_Type));
		roleMap.put("Presentation_Type_Role", new Role("Presentation_Type_Role", Presentation_Type));
		roleMap.put("ContentRepositoryProxy_Type_Role", new Role("ContentRepositoryProxy_Type_Role", ContentRepositoryProxy_Type));
		roleMap.put("PresentationProxy_Type_Role", new Role("PresentationProxy_Type_Role", PresentationProxy_Type));

		//Create ROLES for the Component Framework
		Role[] ROLES = new Role[]{
			(Role)roleMap.get("BrowserProxy_Type_Role"),
			(Role)roleMap.get("ContentRepository_Type_Role"),
			(Role)roleMap.get("MembershipProxy_Type_Role"),
			(Role)roleMap.get("Presentation_Type_Role"),
			(Role)roleMap.get("ContentRepositoryProxy_Type_Role"),
			(Role)roleMap.get("PresentationProxy_Type_Role")
		};

		ComponentFrameworkModel fwModel = new ComponentFrameworkModel(ROLES);



		//Create composition plan(s) for isFull composite realization

		//Node Deployment spec(s)

		NodeDeploymentSpec[] isFull_Dep = new NodeDeploymentSpec[]{
			new NodeDeploymentSpec((Role)roleMap.get("BrowserProxy_Type_Role"), "MASTER"),
			new NodeDeploymentSpec((Role)roleMap.get("ContentRepository_Type_Role"), "MASTER"),
			new NodeDeploymentSpec((Role)roleMap.get("MembershipProxy_Type_Role"), "MASTER"),
			new NodeDeploymentSpec((Role)roleMap.get("Presentation_Type_Role"), "MASTER")
		};

		//Connection spec

		ConnectionSpec[] isFull_Con = new ConnectionSpec[]{
			new ConnectionSpec((Role)roleMap.get("ContentRepository_Type_Role"), "<ms", (Role)roleMap.get("MembershipProxy_Type_Role"), ">ms"),
			new ConnectionSpec((Role)roleMap.get("ContentRepository_Type_Role"), ">ca", (Role)roleMap.get("Presentation_Type_Role"), "<ca"),
			new ConnectionSpec((Role)roleMap.get("Presentation_Type_Role"), ">pn", (Role)roleMap.get("BrowserProxy_Type_Role"), "<pn")
		};

		//Port delegation specification

		PortDelegationSpec[] portDelegation_isFull = new PortDelegationSpec[]{
		};

		//Feature specification

		Vector featureSpec_isFull = new Vector();

		FeatureTypeAssociation[] featureTypeAssocs_isFull = new FeatureTypeAssociation[featureSpec_isFull.size()];
		featureTypeAssocs_isFull = (FeatureTypeAssociation[])featureSpec_isFull.toArray(new FeatureTypeAssociation[featureSpec_isFull.size()]);
		CompositionSpec isFull_compositionSpec = new CompositionSpec(fwModel, isFull_Dep, isFull_Con, portDelegation_isFull, featureTypeAssocs_isFull);
		String[] contextDep_isFull = {
			new String("#Thing.Concept.EntityType.Device;#Thing.Concept.Scope.Roi")
		};

		//CompositionPlan isFull_Plan = new CompositionPlan(isFull_Name, InstantSocial, "InstantSocial.isFull", contextDep_isFull, isFull_compositionSpec);

		CompositionPlan isFull_Plan = new CompositionPlan(isFull_Name, InstantSocial, isFull.class.getName(), contextDep_isFull, isFull_compositionSpec);

		//Properties and property predictors

		{

			Map propertyMap = myCreateMap(
				new String[]{"avy", "rut", IPropertyEvaluator.UTILITY_PROPERTY },
					new Object[]{
						new isFull_isFull_AvyEvaluator(), 
						new isFull_isFull_RutEvaluator(), 
						new Utility()});

			Map resourceMap = myCreateMap(
				new String[]{},
					new Object[]{});

			Feature[] features = {
			};

			isFull_Plan.addPlanVariant(propertyMap, null, resourceMap, features);

		}



		//Create composition plan(s) for isMini composite realization

		//Node Deployment spec(s)

		NodeDeploymentSpec[] isMini_Dep = new NodeDeploymentSpec[]{
			new NodeDeploymentSpec((Role)roleMap.get("BrowserProxy_Type_Role"), "MASTER"),
			new NodeDeploymentSpec((Role)roleMap.get("ContentRepositoryProxy_Type_Role"), "MASTER"),
			new NodeDeploymentSpec((Role)roleMap.get("Presentation_Type_Role"), "MASTER")
		};

		//Connection spec

		ConnectionSpec[] isMini_Con = new ConnectionSpec[]{
			new ConnectionSpec((Role)roleMap.get("BrowserProxy_Type_Role"), "<pn", (Role)roleMap.get("Presentation_Type_Role"), ">pn"),
			new ConnectionSpec((Role)roleMap.get("ContentRepositoryProxy_Type_Role"), ">ca", (Role)roleMap.get("Presentation_Type_Role"), "<ca")
		};

		//Port delegation specification

		PortDelegationSpec[] portDelegation_isMini = new PortDelegationSpec[]{
		};

		//Feature specification

		Vector featureSpec_isMini = new Vector();

		FeatureTypeAssociation[] featureTypeAssocs_isMini = new FeatureTypeAssociation[featureSpec_isMini.size()];
		featureTypeAssocs_isMini = (FeatureTypeAssociation[])featureSpec_isMini.toArray(new FeatureTypeAssociation[featureSpec_isMini.size()]);
		CompositionSpec isMini_compositionSpec = new CompositionSpec(fwModel, isMini_Dep, isMini_Con, portDelegation_isMini, featureTypeAssocs_isMini);
		String[] contextDep_isMini = {
			new String ("#Thing.Concept.EntityType.Device;#Thing.Concept.Scope.Roi")
		};

		//CompositionPlan isMini_Plan = new CompositionPlan(isMini_Name, InstantSocial, "InstantSocial.isMini", contextDep_isMini, isMini_compositionSpec);

		CompositionPlan isMini_Plan = new CompositionPlan(isMini_Name, InstantSocial, isMini.class.getName(), contextDep_isMini, isMini_compositionSpec);

		//Properties and property predictors

		{

			Map propertyMap = myCreateMap(
				new String[]{"avy", "rut", IPropertyEvaluator.UTILITY_PROPERTY },
					new Object[]{
						new isMini_isMini_AvyEvaluator(), 
						new isMini_isMini_RutEvaluator(), 
						new Utility()});

			Map resourceMap = myCreateMap(
				new String[]{},
					new Object[]{});

			Feature[] features = {
			};

			isMini_Plan.addPlanVariant(propertyMap, null, resourceMap, features);

		}



		//Create composition plan(s) for isLeech composite realization

		//Node Deployment spec(s)

		NodeDeploymentSpec[] isLeech_Dep = new NodeDeploymentSpec[]{
			new NodeDeploymentSpec((Role)roleMap.get("BrowserProxy_Type_Role"), "MASTER"),
			new NodeDeploymentSpec((Role)roleMap.get("PresentationProxy_Type_Role"), "MASTER")
		};

		//Connection spec

		ConnectionSpec[] isLeech_Con = new ConnectionSpec[]{
			new ConnectionSpec((Role)roleMap.get("PresentationProxy_Type_Role"), ">pn", (Role)roleMap.get("BrowserProxy_Type_Role"), "<pn")
		};

		//Port delegation specification

		PortDelegationSpec[] portDelegation_isLeech = new PortDelegationSpec[]{
		};

		//Feature specification

		Vector featureSpec_isLeech = new Vector();

		FeatureTypeAssociation[] featureTypeAssocs_isLeech = new FeatureTypeAssociation[featureSpec_isLeech.size()];
		featureTypeAssocs_isLeech = (FeatureTypeAssociation[])featureSpec_isLeech.toArray(new FeatureTypeAssociation[featureSpec_isLeech.size()]);
		CompositionSpec isLeech_compositionSpec = new CompositionSpec(fwModel, isLeech_Dep, isLeech_Con, portDelegation_isLeech, featureTypeAssocs_isLeech);
		String[] contextDep_isLeech = {
		};

		//CompositionPlan isLeech_Plan = new CompositionPlan(isLeech_Name, InstantSocial, "InstantSocial.isLeech", contextDep_isLeech, isLeech_compositionSpec);

		CompositionPlan isLeech_Plan = new CompositionPlan(isLeech_Name, InstantSocial, isLeech.class.getName(), contextDep_isLeech, isLeech_compositionSpec);

		//Properties and property predictors

		{

			Map propertyMap = myCreateMap(
				new String[]{"avy", "rut", IPropertyEvaluator.UTILITY_PROPERTY },
					new Object[]{
						new isLeech_isLeech_AvyEvaluator(), 
						new isLeech_isLeech_RutEvaluator(), 
						new Utility()});

			Map resourceMap = myCreateMap(
				new String[]{},
					new Object[]{});

			Feature[] features = {
			};

			isLeech_Plan.addPlanVariant(propertyMap, null, resourceMap, features);

		}

		return new CompositionPlan[]{
			isFull_Plan,
			isMini_Plan,
			isLeech_Plan
		};
	} //getCompositionPlans()
	public IPlan[] getPlans(){
		IPlan[] atomicPlans = getAtomicPlans();
		IPlan[] compositionPlans = getCompositionPlans();
		IPlan[] servicePlans = getServicePlans();

		IPlan[] plans = new IPlan[atomicPlans.length + compositionPlans.length + servicePlans.length];
		System.arraycopy(atomicPlans, 0, plans, 0, atomicPlans.length);
		System.arraycopy(compositionPlans, 0, plans, atomicPlans.length, compositionPlans.length);
		System.arraycopy(servicePlans, 0, plans, atomicPlans.length+compositionPlans.length, servicePlans.length);
		return plans;
	}
	public ApplicationType[] getApplicationTypes(){
		ApplicationType[] application = new ApplicationType[] {
			new ApplicationType(InstantSocial, null) };
		return application;
	}

	public ComponentType[] getComponentTypes(){

		//Declaration of a component type realized by a service
		//port zero - Presentation?
		PortDescription portDescription0 = new PortDescription("service:music:PresentationService");
		ComponentType serviceComponentType0 = new ComponentType(PresentationProxy_Type, null);
		PortType portType0 = new PortType(new String[]{shared.IPresentationServiceProvider.class.getName()}, new String[]{});
		//PortType portType0 = new PortType(new String[]{"InstantSocial.IPresentationServiceProvider"}, new String[]{});
		portType0.setPortDescription(portDescription0);
		serviceComponentType0.setPortType("ServiceProvided", portType0);
		
		//port one - ContentRepository?
		PortDescription portDescription1 = new PortDescription("service:music:MembershipService");
		ComponentType serviceComponentType1 = new ComponentType(MembershipProxy_Type, null);
		PortType portType1 = new PortType(new String[]{shared.IMembershipServiceProvider.class.getName()}, new String[]{});
		//PortType portType1 = new PortType(new String[]{"InstantSocial.IMembershipServiceProvider"}, new String[]{});
		portType1.setPortDescription(portDescription1);
		serviceComponentType1.setPortType("ServiceProvided", portType1);
		
		//port two - Membership?
		PortDescription portDescription2 = new PortDescription("service:music:ContentRepositoryService");
		ComponentType serviceComponentType2 = new ComponentType(ContentRepositoryProxy_Type, null);
		PortType portType2 = new PortType(new String[]{shared.IContentRepositoryServiceProvider.class.getName()}, new String[]{});
		//PortType portType2 = new PortType(new String[]{"InstantSocial.IContentRepositoryServiceProvider"}, new String[]{});
		portType2.setPortDescription(portDescription2);
		serviceComponentType2.setPortType("ServiceProvided", portType2);

		//RIGHT WAY?
		return new ComponentType[]{		
			serviceComponentType0,
			serviceComponentType1,
			serviceComponentType2,
			new ComponentType(BrowserProxy_Type, null),
			new ComponentType(Presentation_Type, null),
			new ComponentType(ContentRepository_Type, null)
		};
	}

	public IPlan[] getExtensionPlans(){
        return new IPlan[0];
    }

	class Utility implements IPropertyEvaluator{
		public Object evaluate(IContextValueAccess context, IPropertyEvaluatorContext evalContext)
		{
			System.out.println("calculating utility");

			int avy = Integer.parseInt((evalContext.evaluate("avy", context)).toString());
			int rut = Integer.parseInt((evalContext.evaluate("rut", context)).toString());
			
			System.out.println("Current avy is : " + avy);
			System.out.println("Current rut is : " + rut);
			
			//int avy = ((Integer) evalContext.evaluate("avy", context)).intValue();
			//int rut = ((Integer) evalContext.evaluate("rut", context)).intValue();
//#BlockStart number=1 id=_iXAadoPGEduaib1rbQg5jQ_#_0

			//relative weights of avy and rut!
			int c1 = 1;
			int c2 = 1;
			
			double utility = (c1 * avy + c2 * (100 - rut)) / (c1 + c2); 
			System.out.println("calculated utility is : " + utility);
			
//#BlockEnd number=1


			//return new Double(utility);
			return utility;
		}
	}

	class isFull_isFull_AvyEvaluator implements IPropertyEvaluator{
		public Object evaluate(IContextValueAccess context, IPropertyEvaluatorContext evalContext)
		{
//#BlockStart number=2 id=EAID_8741DFB9_0385_44a3_B496_06F06316052F_#_0
//#BlockEnd number=2

			System.out.println("calculating isFull AVY");
			String noiString = ((String) evalContext.evaluateForRole("noi", context, "MembershipProxy_Type_Role"));
			System.out.println("isFull noi is : " + noiString);
			
			int noi = Integer.parseInt(noiString) + 1;
			
			int avy = 30;
			
			if(noi == 1){
				avy = 70;
			}
			else if(noi == 2){
				avy = 90;
			}
			else if(noi > 2){
				avy = 100;
			}
			
//#BlockStart number=3 id=_iXAadoPGEduaib1rbQg5jQ_#_1
//#BlockEnd number=3

			
			
			return String.valueOf(avy);
		}
	}

	class isFull_isFull_RutEvaluator implements IPropertyEvaluator{
		public Object evaluate(IContextValueAccess context, IPropertyEvaluatorContext evalContext)
		{
			
			System.out.println("calculating isFull RUT");
			Object crut = context.getValue("#Thing.Concept.EntityType.Device;#Thing.Concept.Scope.Roi");
			int rut = defaultCrut;
			if(crut != null){
				System.out.println("isFull CRUT is : " + crut.toString());
				rut = Integer.parseInt(crut.toString());
			}
			else{
				System.out.println("isFull CRUT is null, using " + defaultCrut);
			}
			
			
//#BlockStart number=4 id=_iXAadoPGEduaib1rbQg5jQ_#_2
//#BlockEnd number=4


			return String.valueOf(rut);
		}
	}

	class isMini_isMini_AvyEvaluator implements IPropertyEvaluator{
		public Object evaluate(IContextValueAccess context, IPropertyEvaluatorContext evalContext)
		{
			System.out.println("calculating isMini AVY");
			String avyString = ((String) evalContext.evaluateForRole("avy", context, "ContentRepositoryProxy_Type_Role"));
			System.out.println("isMini avy is : " + avyString);
			
			
			
//#BlockStart number=5 id=EAID_D42643D6_9242_4ed3_91C2_B73B059D71B7_#_0
//#BlockEnd number=5
			
//#BlockStart number=6 id=_iXAadoPGEduaib1rbQg5jQ_#_3
//#BlockEnd number=6


			return avyString;
		}
	}

	class isMini_isMini_RutEvaluator implements IPropertyEvaluator{
		public Object evaluate(IContextValueAccess context, IPropertyEvaluatorContext evalContext)
		{
			System.out.println("calculating isMini RUT");
			String rutString = ((String) evalContext.evaluateForRole("rut", context, "ContentRepositoryProxy_Type_Role"));
			System.out.println("isMini CA rut is : " + rutString);
			int carut = Integer.parseInt(rutString);
			
			Object crutobj = context.getValue("#Thing.Concept.EntityType.Device;#Thing.Concept.Scope.Roi");
			int crut = defaultCrut;
			if(crutobj != null){
				System.out.println("isMini CRUT is : " + crutobj.toString());
				crut = Integer.parseInt(crutobj.toString());
			}
			else{
				System.out.println("isMini CRUT is null, using " + defaultCrut);
			}
			
			
			
//#BlockStart number=7 id=EAID_DC6CD67C_561C_42a9_8E40_1AF49394831E_#_0
//#BlockEnd number=7

//#BlockStart number=8 id=_iXAadoPGEduaib1rbQg5jQ_#_4
//#BlockEnd number=8

			if(carut > crut){
				return String.valueOf(carut);
			}
			return String.valueOf(crut);
		}
	}

	class isLeech_isLeech_AvyEvaluator implements IPropertyEvaluator{
		public Object evaluate(IContextValueAccess context, IPropertyEvaluatorContext evalContext)
		{
			System.out.println("calculating isLeech AVY");
			String avyString = ((String) evalContext.evaluateForRole("avy", context, "PresentationProxy_Type_Role"));
			System.out.println("isLeech avy is : " + avyString);
			
			
//#BlockStart number=9 id=EAID_7F8F5DCE_5613_472c_B7C5_33C9D726DB91_#_0
//#BlockEnd number=9
		
//#BlockStart number=10 id=_iXAadoPGEduaib1rbQg5jQ_#_5
//#BlockEnd number=10


			return avyString;
		}
	}

	class isLeech_isLeech_RutEvaluator implements IPropertyEvaluator{
		public Object evaluate(IContextValueAccess context, IPropertyEvaluatorContext evalContext)
		{
			System.out.println("calculating isLeech RUT");
			String rutString = ((String) evalContext.evaluateForRole("rut", context, "PresentationProxy_Type_Role"));
			System.out.println("isLeech rut is : " + rutString);
			
//#BlockStart number=11 id=EAID_0FA7FCF5_F8A8_4ff0_86BE_26DB029F729A_#_0
//#BlockEnd number=11

//#BlockStart number=12 id=_iXAadoPGEduaib1rbQg5jQ_#_6
//#BlockEnd number=12

			
			return rutString;
		}
	}    
    private HashMap myCreateMap(String[] keys, Object[] values){

        HashMap propMap = new HashMap();
        for(int i = 0; i < keys.length; i++){
            propMap.put(keys[i], values[i]);
        }

        return propMap;


    }
    
} // End of class InstantSocial