package InstantSocial;

import java.util.ArrayList;

import javax.swing.ImageIcon;

import org.istmusic.mw.adaptation.configuration.ConfigurableImpl;
import org.istmusic.mw.model.connectable.IConnectable;

import shared.*;

public class LocalPresentation extends ConfigurableImpl implements IPresentationServiceProvider, IConnectable{

	private IContentRepositoryServiceProvider contentRep;
	
	@Override
	public ArrayList<ImageIcon> getAllThumbnails() {
		
		if(contentRep != null){
			ArrayList<ImageIcon> list = new ArrayList<ImageIcon>();
			ArrayList<ISFile> files = contentRep.getAllFiles();
		
			for (ISFile file : files) {
			
				ImageIcon i = file.getThumbicon();
				i.setDescription(file.getFilename());
				list.add(i);
			
			}
			return list;
		}
		else{
			System.out.println("Error, no contentrep connected to local presentation!");
			return null;
		}
	}

	@Override
	public ImageIcon getSingleFullImage(String filename) {
		if(contentRep != null){
			System.out.println("local presentation getting file: " + filename);
			ISFile file = contentRep.getFile(filename);
			if( file != null){
				//System.out.println("local pres getting : " + filename);
				return file.getIcon();
			}
		}
		else{
			System.out.println("Error, no contentrep connected to local presentation!");
		}
		return null;
	}

	@Override
	public void addConnection(String arg0, Object arg1) {
		if(arg0.equals("<ca")){
			contentRep = (IContentRepositoryServiceProvider) arg1;
		}
	}

	@Override
	public void removeConnection(String arg0, Object arg1) {
		contentRep = null;
		
	}

}
