package shared.roiContext.model;

import java.util.Set;
import java.util.HashSet;

import org.istmusic.mw.context.model.api.*;
import org.istmusic.mw.context.model.impl.Factory;

public class RoiContextData implements IContextData
{
    private final RoiContextValue roiContextValue;

    public RoiContextData(final int roi)
    {
        this.roiContextValue = new RoiContextValue(roi);
    }

    public double getRoi()
    {
        return roiContextValue.getRoi();
    }

    public IContextValue getContextValue(IScope scope)
    {
        if(RoiContextValue.ROI_CONTEXT_VALUE_SCOPE.equals(scope))
        {
            return roiContextValue;
        }
        else
        {
            return null;
        }
    }

    public IValue getValue(IScope scope)
    {
        final IContextValue roiContextValue = getContextValue(scope);

        return roiContextValue == null ? null : roiContextValue.getValue();
    }

    public Set keySet()
    {
        // TODO What is this!?
        // This must return all scope keys available in this context data, as a set

        final Set keys = new HashSet();
        keys.add(RoiContextValue.ROI_CONTEXT_VALUE_SCOPE);

        return keys;
    }

}
