package shared.roiContext.model;

import org.istmusic.mw.context.model.api.*;
import org.istmusic.mw.context.model.impl.Factory;

public class RoiContextElement implements IContextElement
{

    public static final IEntity ENTITY = Factory.createEntity("#Thing.Concept.EntityType.Device");
    public static final IScope SCOPE = Factory.createScope("#Thing.Concept.Scope.Roi");

    private final String source;
    private final RoiContextData roiContextData;
    private final IMetadata metadata;

    public RoiContextElement(final String source, final int roi)
    {
        super();
        this.source = source;
        this.roiContextData = new RoiContextData(roi);
        this.metadata = Factory.createDefaultMetadata();
    }

    public double getRoi()
    {
        return roiContextData.getRoi();
    }

    public IContextData getContextData()
    {
        return roiContextData;
    }

    public IEntity getEntity()
    {
        return ENTITY;
    }

    public IMetadata getMetadata()
    {
        return metadata;
    }

    public IRepresentation getRepresentation()
    {
        // TODO Auto-generated method stub
        return null;
    }

    public IScope getScope()
    {
        return SCOPE;
    }

    public String getSource()
    {
        return source;
    }
}