package control;

import java.io.*;
import java.util.*;
import javax.swing.*;

import membershipServicePart.MembershipServiceFront;
import contentRepositoryServicePart.ContentRepositoryServiceFront;
import control.GraphicalControls.ControlFrame;
import presentationServicePart.PresentationServiceFront;



import repository.FullFileRepository;

public class TestControls {
	
	private static FullFileRepository rep;
	private PresentationServiceFront presentation;
	private ContentRepositoryServiceFront contentrep;
	private MembershipServiceFront membership;
	
	private ControlFrame frame;
	
	static BufferedReader stdin = new BufferedReader(new InputStreamReader(System.in));
	static StringTokenizer st = new StringTokenizer("");
	
	
	private boolean running;
	
	
	public TestControls() {
		
		rep = new FullFileRepository();
		
		presentation = new PresentationServiceFront(rep);
		contentrep = new ContentRepositoryServiceFront(rep);
		membership = new MembershipServiceFront(rep);
		
		running = true;
		//LobbyControl.getLobbyControl();
		System.out.println("running!");
		
		
		//start gui:
		frame = new ControlFrame();
		
		//command reading:
		readCommands();
		
	}
	
	private void readCommands(){
		
		
		while(running){
		String command;
			try {
				command = readString();
			
				if(command.equals("shutdown")){
					System.out.println("Shutdown Command Received");
					System.out.println("Shutting down");
					running = false;
				}
				else if(command.equals("load")){
					command = readString();
					
					if(command.equals("1")){
						rep.LoadTestFiles(1);
						System.out.println("loaded");
					}
					
					
				}
				
			
			} catch (Exception e) {
				System.out.println("Command Read Error!");
			}
		}
		
		System.out.println("no longer reading commands");
	}
	
	
	
	public static void main(String args[]){
		
		
		
		
		
		JFrame frame = new JFrame("TestEnvironment");
		frame.setVisible(true);
		frame.setLocation(2000, 300);
		frame.setSize(200, 50);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		JLabel lbl = new JLabel("TestEnvironment is running..");
		frame.add(lbl);
		
		TestControls t = new TestControls();
		
		frame.dispose();
		//LobbyCommand com = new LobbyCommand();
	}

	// Read next input-token as string.
	static String readString() throws Exception {
		while (!st.hasMoreTokens()) {
			st = new StringTokenizer(stdin.readLine());
		}
		return st.nextToken();
	}

	// Read next input-token as integer.
	static int readInt() throws Exception {
		return Integer.parseInt(readString());
	}

	// Read next input-token as double.
	static double readDouble() throws Exception {
		return Double.parseDouble(readString());
	}
	
	
	
}