package presentationServicePart;

import java.util.ArrayList;

import javax.swing.ImageIcon;

import repository.FullFileRepository;
import repository.ISFile;

public class PresentationServiceFront implements IPresentationServiceProvider {

	private FullFileRepository rep;
	
	public PresentationServiceFront(FullFileRepository rep){
		this.rep = rep;
	}

	@Override
	public ArrayList<ImageIcon> getAllThumbnails() {
		ArrayList<ImageIcon> list = new ArrayList<ImageIcon>();
		ArrayList<ISFile> files = rep.getFiles();
		
		for (ISFile file : files) {
			
			ImageIcon i = file.getThumbicon();
			i.setDescription(file.getFilename());
			list.add(i);
			
		}
		return list;
		
	}

	@Override
	public ImageIcon getSingleFullImage(String filename) {
		System.out.println("remote presentation getting file: " + filename);
		ISFile file = rep.getFile(filename);
		if( file != null){
			return file.getIcon();
		}
		return null;
	}
	
	
	
	/*
	@Override
	public String getAllThumbnails() {
		String xmlOutputString = new String();
		
		xmlOutputString = xmlOutputString.concat("<xml>");
		
			ArrayList<ISFile> files = rep.getFiles();
			
			for (ISFile file : files) {
				xmlOutputString = xmlOutputString.concat("<picture>");
				
				xmlOutputString = xmlOutputString.concat(file.getFilename());
				
				xmlOutputString = xmlOutputString.concat("</picture>");
				
			}
		
			xmlOutputString = xmlOutputString.concat("</xml>");
		
		return xmlOutputString;
	}
	 */
}
